DOJ logoDOJ
문제
최근 추가된 문제들저장한 문제문제집
카테고리DLC대회그룹팀게시판
랭킹
문제 풀이 랭킹스트릭 랭킹DOJ Power 랭킹
현황
문제 제안로그인회원가입
DOJ logoDOJ

OI 서브태스크 채점, Elo 레이팅, Discord 인증을 갖춘 커뮤니티 온라인 저지.

문제
문제 목록카테고리
커뮤니티
대회랭킹게시판공지사항외부 대회 개최이용 안내
계정
로그인회원가입채점 현황
정책
이용약관DLC 이용 규칙개인정보 처리방침API 사용 설명서언어별 채점 환경대회 순위 보상레이팅과 퍼포먼스
© 2026 DOJ
모든 권리 보유
해설

일부는 시즈모드 됐고 일부는 퉁퉁퉁퉁퉁퉁!

문제로 돌아가기

해설

낭비되는 공성 공격 제거

양 끝 위치를 대상으로 하는 공성 공격은 체력의 합을 최대 333만큼 내린다. N=1N=1N=1이면 최대 222만큼 내린다. 같은 체력 감소를 전차 모드의 공격들로 비용 333 이하에 재현할 수 있으므로, 양 끝을 대상으로 하는 공성 공격을 사용하지 않는 최적해가 존재한다.

공성 모드의 공격 한 번은 체력을 최대 444만큼 내린다. 체력 000에서 잘려 피해가 하나라도 낭비되었다면 실제로 내린 체력의 합은 333 이하이다. 그 공격을 실제로 내린 체력만큼의 전차 모드 공격으로 대체하면 같은 상태를 비용 333 이하로 만들 수 있다. 따라서 최적해는 모든 공성 공격의 피해가 온전히 적용되는 형태로 잡을 수 있다.

공성 공격의 횟수 최대화

iii번 위치를 대상으로 하는 공성 공격의 횟수를 xix_ixi​라 하자. 위의 관찰에 따라 양 끝의 공격을 제외하고, x0=x1=xN=xN+1=0x_0=x_1=x_N=x_{N+1}=0x0​으로 둔다. 각 위치에서 다음 조건을 만족해야 한다.

xi−1+2xi+xi+1≤ai.x_{i-1}+2x_i+x_{i+1}\le a_i.xi−1​+2xi​+x

이 조건이 성립하면 공성 공격들을 어떤 순서로 하더라도 피해가 낭비되지 않는다. 남은 체력은 전차 모드로 처리할 수 있다. K=∑ixiK=\sum_i x_iK=∑i​xi​라 하면 공성 공격이 체력의 합을 4K4K4K만큼 줄이므로 총비용은

3K+∑i=1Nai−4K=∑i=1Nai−K3K+\sum_{i=1}^{N}a_i-4K=\sum_{i=1}^{N}a_i-K3K+i=1∑N​ai​

이다. 따라서 위 조건을 만족하는 정수 xi≥0x_i\ge0xi​≥0의 합을 최대화하면 된다.

동적 계획법

M=max⁡iaiM=\max_i a_iM=maxi​ai​, B=⌊M/2⌋B=\lfloor M/2\rfloorB=⌊라 하자. 모든 는 이상 이하이다.

iii번 위치를 처리하기 직전의 dp[p][q]\mathrm{dp}[p][q]dp[p][q]를 다음과 같이 정의한다. i−1i-1i−1번 위치까지의 조건을 만족하고 xi−1=px_{i-1}=px, 일 때, 이미 정한 의 합의 최댓값이다. 불가능한 상태는 음의 무한대로 둔다. 처음에는 이고 나머지는 불가능하다.

r=xi+1r=x_{i+1}r=xi+1​을 정하면 p+2q+r≤aip+2q+r\le a_ip+2q+r≤를 만족해야 하므로 전이는

next[q][r]=r+max⁡0≤p≤min⁡(B,ai−2q−r)dp[p][q]\mathrm{next}[q][r]=r+\max_{0\le p\le\min(B,a_i-2q-r)}\mathrm{dp}[p][q]next[q][r]=r+0≤p

가 된다. i+1≥Ni+1\ge Ni+1≥N이면 r=0r=0r=0만 허용한다. qqq를 고정하고 ppp 방향의 누적 최댓값을 구하면 각 전이를 에 계산할 수 있다. 마지막 번 위치까지 처리한 뒤 이 공성 공격 횟수의 최댓값이다.

모든 가능한 다음 횟수를 확인하고 정확히 현재 위치의 체력 조건을 검사하므로, 귀납적으로 DP는 가능한 모든 공성 공격 배치와 그 최댓값을 보존한다. 따라서 ∑iai−dp[0][0]\sum_i a_i-\mathrm{dp}[0][0]∑i​ai​−dp[0][0]이 정답이다.

시간 복잡도는 O(N(B+1)2)O(N(B+1)^2)O(N(B+1)2), 공간 복잡도는 O((B+1)2)O((B+1)^2)O((B+1)이다. 이므로 이다. 원소가 모두 인 경우에도 로 표기한 복잡도가 유효하다.

서브태스크

  • 서브태스크 111: 현재 체력 벡터를 상태로 두고 두 공격을 직접 시도한다. 시간은 O(N∏i(ai+1))O(N\prod_i(a_i+1))O(N∏i​(ai​+1)), 공간은 이다. , 이므로 상태 수는 최대 이다.

Solution written by GPT6

=
x1​=
xN​=
xN+1​=
0
i+1
​
≤
ai​.
−
4K=
i=1∑N​ai​−
K
M
/2
⌋
xix_ixi​
000
BBB
i−1
​
=
p
xi=qx_i=qxi​=q
x1,⋯ ,xix_1,\cdots,x_ix1​,⋯,xi​
dp[0][0]=0\mathrm{dp}[0][0]=0dp[0][0]=0
ai​
≤
min
(
B
,
ai​
−
2
q
−
r
)
max
​
dp
[
p
]
[
q
]
O(1)O(1)
O(1)
NNN
dp[0][0]\mathrm{dp}[0][0]dp[0][0]
2
)
M≤100M\le100M≤100
B≤50B\le50B≤50
000
B+1B+1B+1
O(∏i(ai+1))O(\prod_i(a_i+1))O(∏i​(ai​+1))
N≤8N\le8N≤8
ai≤4a_i\le4ai​≤4
58=390 6255^8=390\,62558=390625
  • 서브태스크 222: 누적 최댓값 없이 p,q,rp,q,rp,q,r을 모두 순회하는 DP를 사용한다. 시간은 O(N(B+1)3)O(N(B+1)^3)O(N(B+1)3), 공간은 O((B+1)2)O((B+1)^2)O((B+1)2)이다.
  • 서브태스크 333: 누적 최댓값으로 최적화한 전체 풀이를 사용한다.